︠fff9b57e-e36d-4263-9514-a30f622bddd2s︠
reset
var('x')
︡d67d031a-113f-49c3-98c5-4135be52d407︡{"stdout":"<function reset at 0x7f127d4c20c8>\n"}︡{"stdout":"x\n"}︡{"done":true}
︠345f69b1-5f3f-4386-bd61-d1fdbafdad39︠
#Exercise 1. Make a CAS function fcn_and_tangent(fcn,x0,a,b,c) that takes a differentiable function f, a point x0  in the function domain, end points of an interval that contains the point, and a small float c and returns
# (a) a figure with the function graph on [a,b] and the tangent line passing through the point (x0, f(x0)).
# (b) the relative error of the approximation of f(x0+c) by the linearization at the point x0.
︡8f0e525f-8982-41db-aef6-3bb80f1533cb︡
︠ef28b687-2b02-4edf-8d13-60cbecbbb614s︠
def fcn_and_tangent(fcn,x0,a,b,c):
    fcn_plot=plot(fcn,a,b,color='blue',thickness=2,figsize=[3,2])
    fprime=diff(fcn,x)
    tangent_eq=fcn(x0)+fprime(x=x0)*(x-x0)# Encode the rhs of the equation of the tangent line
    tangent_plot=plot(tangent_eq,a,b,color='green',thickness=2,figsize=[3,2])
    G=fcn_plot+tangent_plot+point([x0,fcn(x=x0)],pointsize=40,color='red')
    rel_error=100*(tangent_eq(x=x0+c)-fcn(x=x0+c))/fcn(x=x0+c)
    print "Error: %s %%\n" % rel_error # Tricky format; just use it as a "black box"
    return G
fcn_and_tangent(cos(x),0.75,0,2,0.1)# Use your own example. Experiment with c, the change in x0
︡e0843b0c-5ca0-44bc-b149-7aa79d0700a7︡{"stdout":"Error: 0.536657187170416 %\n\n"}︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/455/tmp__8q26G.svg","show":true,"text":null,"uuid":"408c6dcf-eaee-48da-9730-93e961d9447e"},"once":false}︡{"done":true}
︠53a02ff7-72ae-4aef-b5aa-a99749eaa5ca︠
#####################
#Exercise 4. Make a CAS function plot_piecewise_fcn(L) that takes a list of data points of a continuous piecewise linear function and returns a figure with the plots of the function and its derivative. Assume that the points on the list L are sorted in the ascending order of their x-coordinates. Test your function on the set of points of your choice.
#y=y0+f(x0)(x-x0)
#y=y+slope(x-xj)
︡a68d6643-d99d-457b-ac64-7f60e7305158︡
︠6fec3dfa-ac97-4d87-95ad-0a3a4826b112s︠

def my_piecewise_fcn(L):
    n=len(L)
    Gf=Graphics();Gfp=Graphics()# Graphics object provides another way of plotting multiple function in one figure
    for j in range(n-1):
        slope=(L[j+1][1]-L[j][1])/(L[j+1][0]-L[j][0])
        fprime=plot(slope,L[j][0],L[j+1][0],thickness=2,color='red')
        Gfp+=fprime
        eq=L[j][1]+slope*(x-L[j][0])
        fcn=plot(eq,L[j][0],L[j+1][0],thickness=2,color='blue')
        Gf+=fcn
    (Gf+Gfp).show(figsize=[4,3])

L=[[4.,1],[2.,3],[3.,-1.],[5.,0]]
my_piecewise_fcn(L)# Use your own example
︡dd1e4dd7-0683-476e-b351-d2faef58f822︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/455/tmp_Mifatw.svg","show":true,"text":null,"uuid":"f4f3dd54-b494-4056-a1c7-84f6b4d5622a"},"once":false}︡{"done":true}
︠a5d11d81-afae-4336-b13f-f32209203babs︠
#Remark: plotting piecewise function as a whole
f=piecewise([([(-1,0),1]),((0,1),2),((1,2),3)])
plot(f(x),(x,-1,2),detect_poles='False',thickness=3,figsize=[3,2])
︡b7668be3-93b2-4f75-ad06-cebaf90a030e︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/455/tmp_p_eGyW.svg","show":true,"text":null,"uuid":"421df106-7578-44d3-974f-623068ce1e60"},"once":false}︡{"done":true}
︠8a78491b-2ec9-483f-9b47-9b81aeab41a3s︠
#########################
#Exercise 2. Make a CAS function f_and_fprime(fcn, a, b) that takes a function differentiable on an interval [a, b] and returns a figure with plots of the function and its derivative on the interval. Use CAS command for finding the derivative function.
# No template. You are on your own.
def f_and_fprime(fcn, a, b)
    G=Graphics()
︡873943dd-04b9-4436-a9cb-1e770e506bd0︡{"stderr":"Error in lines 1-2\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1191, in execute\n    flags=compile_flags), namespace, locals)\n  File \"<string>\", line 1\n    def f_and_fprime(fcn, a, b)\n                              ^\nSyntaxError: invalid syntax\n"}︡{"done":true}
︠cb60c0ca-f798-4e62-98f0-e69bcc9ca77c︠
###############################
#Exercise 5 (demo). Make a CAS function my_bisection(f, a, b, n) that takes function f,end points of an interval with a single root of the function, and a real number eps and returns the approximation of the root. The steps of the bisection method are repeated while the value of f at the midpoint of the current interval exceeds eps.Test your code on an example of your choice.
︡4ae93168-22c6-47a3-bcac-39a6977b24e5︡
︠722622a4-05cc-4608-a8ac-ee8bdf61b15bs︠

︡a60e8ced-d31d-4f13-9c02-f289b15247c2︡{"done":true}
︠ee37553e-92b1-442b-b277-c0ec4d23831as︠
#This code is a simplified fragment from function written by William Stein, the founder of SageMath
def bisect(f,a,b,eps):
    two = float(2)
    while True:
        c = (a+b)/two
        fa = f(a); fb = f(b); fc = f(c)
        if abs(fc) < eps: return c
        if fa*fc < 0:
            a, b = a, c
        elif fc*fb < 0:
            a, b = c, b
        else:
            raise ValueError, "f must have a sign change in the interval (%s,%s)"%(a,b)
f(x)=cos(x)-x
bisect(f,0,1,0.001)
︡e9177ab5-8f02-450b-9dab-28f75a28a799︡{"stdout":"0.7392578125\n"}︡{"done":true}
︠fae82b5f-b117-45ee-8e36-f7c320912ad5s︠
f(_)
#Remark about notation f(_):# The underline stand for the previous result of calculation
︡ac6e1562-eb7d-4110-a92d-5f7e07abab13︡{"stdout":"-x + cos(x)\n"}︡{"done":true}
︠d50a65bf-e572-4bd1-bcbd-8c8a277713ffs︠
######################
#Exercise 6. Make a CAS function my_MVT(f, a, b) that takes a function continuous on interval [a, b]  and differentiable in (a,b) and returns a figure similar to Fig. 6.4 in Lecture 6. You will need CAS root-finding command.
def my_MVT(f,a,b):
    G=Graphics()
    f_plot=plot(f,a,b,thickness=2,color='blue')
    G+=f_plot
    secant_slope=(f(x=b)-f(x=a))/(b-a)# enter the expression for the secant slope
    secant_plot=plot(f(x=a)+secant_slope*(x-a),a,b,thickness=2,color='red')# enter the expression for the secant equation
    G+=secant_plot
    #Find the x-coordinate of the point of tangency for tangent parallel to the secant
    t=find_root(diff(f(x),x)==secant_slope,a,b)
    tangent_plot=plot(f(x=t)+secant_slope*(x-t),a,b,thickness=2,color='red')
    G+=tangent_plot
    G.show(figsize=[4,3])
my_MVT(sin(x),-1,3)
︡2dd6e501-9afc-411a-951b-ef900f765f44︡{"file":{"filename":"/home/user/.sage/temp/project-be2f3be2-a2f6-46e2-a20d-d2cd7754c56e/455/tmp_XTnl4m.svg","show":true,"text":null,"uuid":"405f4d21-1372-4779-ada2-d68686e195e5"},"once":false}︡{"done":true}
︠4795f0d5-16ed-4392-b06e-d95e0a102b42︠

︡5dc013f7-7218-4a57-ae7e-06a222619f66︡
︠89c4a4ca-b612-4d76-ae4f-010b5719c0cf︠









